#include "mapmet.h"
#include "ui_mapmet.h"
#include <QMessageBox>

Mapmet::Mapmet(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::Mapmet)
{
    ui->setupUi(this);
    ui->statusBar->showMessage("Waiting for a new connection");
    e_thread = new MEvaluator(this);
    e_thread->listen(QHostAddress::Any, 12011);
    m_server = new MServer(this);
    m_server->listen(QHostAddress::Any, 12012);

    message_array.append("Danger!| Fallback silently.| Enemy troops ahead.| Report your condition.");
    message_array.append("Don't go there!| Crossfire possible.| Follow auxiliary path.| Watch your step.");
    message_array.append("bidi");
    message_array.append("bodo");
    message_array.append("nane");
    message_array.append("zede");
    message_array.append("yede");
    message_array.append("kede");
    message_array.append("kedi");
}

Mapmet::~Mapmet()
{
    delete ui;
}

void Mapmet::setSendButton(bool val)
{
    ui->sendButton->setEnabled(val);
}

void Mapmet::setStatusBar(QString val, int to)
{
    ui->statusBar->showMessage(val, to);
}

void Mapmet::on_actionExit_triggered()
{
    m_server->closeSocket();
    e_thread->closeSocket();
    this->close();
}

void Mapmet::on_actionAbout_triggered()
{
    QMessageBox::information(this, "About", "Mapmet is a cool system for cool people!", "OK");
}

void Mapmet::on_sendButton_clicked()
{
    QString message;
    QString sender = ui->senderbox->text();
    sender = sender.trimmed();

    if (sender.isEmpty())
        sender = "Command Center";

    if (ui->messages->selectedItems().isEmpty())
    {
        QMessageBox::warning(this, "No message!", "You must select a message to proceed.", "OK");
        return;
    }

    message = message_array[ui->messages->row(ui->messages->selectedItems()[0])];

    m_server->sendMsg(sender, message);
}
