#ifndef MEVALUATOR_H
#define MEVALUATOR_H

#include <QThread>
#include "cv.h"
#include "highgui.h"
#include <math.h>
#include <QQueue>
#include <QTcpServer>
#include <QTcpSocket>

class MEvaluator:public QTcpServer
{
    Q_OBJECT

public:
    MEvaluator(QObject *parent = 0);
    void closeSocket();

    QTcpSocket sck;

protected:
    QObject * parent;
    static const double pi = 3.14159265358979323846;

    int getFrames();
    void evaluateFrames(int, double);
    void allocateOnDemand(IplImage **img, CvSize size, int depth, int channels);
    double square(int a);
    int summer(QQueue<int> &list);
    int findmedian(QQueue<int> &list, int accum);
    void incomingConnection(int socketDescriptor);
};

#endif // MEVALUATOR_H
