#include "mapmet.h"
#include "mserver.h"

MServer::MServer(QObject *parent)
    : QTcpServer(parent)
{
    this->parent = parent;
    connect(&sck, SIGNAL(disconnected()), this, SLOT(discHandler()));
}

void MServer::incomingConnection(int socketDescriptor)
{
    ((Mapmet *)parent)->setSendButton(true);
    ((Mapmet *)parent)->setStatusBar("Connection Established!", 0);
    sck.setSocketDescriptor(socketDescriptor);
}

void MServer::sendMsg(QString sender, QString message)
{
    QByteArray block = "";
    block.append(sender);
    block.append("|");
    block.append(message);
    block.append("\n");

    sck.write(block);

    ((Mapmet *)parent)->setStatusBar("Message Sent!", 3000);
}

void MServer::closeSocket()
{
    sck.disconnectFromHost();
    sck.waitForDisconnected();
}

void MServer::discHandler()
{
    ((Mapmet *)parent)->setSendButton(false);
    ((Mapmet *)parent)->setStatusBar("Connection Lost",0);
}
